/*
 * debounce.h
 *
 * Created: 23.04.2016 20:38:16
 *  Author: Hannes
 */ 

#ifndef DEBOUNCE_H_
#define DEBOUNCE_H_

#include <stdint.h>


#define KEY_DDR         DDRB
#define KEY_PORT        PORTB
#define KEY_PIN         PINB
#define KEY0            PINB2
#define KEY1            PINB1
#define KEY2            PINB3
#define ALL_KEYS        (1<<KEY0 | 1<<KEY1 | 1<<KEY2)
 
#define REPEAT_MASK     (1<<KEY1 | 1<<KEY2)       // repeat: key1, key2
#define REPEAT_START    50                        // after 50000ms
#define REPEAT_NEXT     20                        // every 200ms


uint8_t get_key_press( uint8_t key_mask );
uint8_t get_key_rpt( uint8_t key_mask );
uint8_t get_key_state( uint8_t key_mask );
uint8_t get_key_short( uint8_t key_mask );
uint8_t get_key_long( uint8_t key_mask );

#endif /* DEBOUNCE_H_ */
 
