/*
 * led_modes.c
 *
 * Created: 05.05.2016 23:25:26
 *  Author: Hannes
 */ 

#include "includes/light_ws2812.h"
#include <math.h>
#include <stdlib.h>

#define MAX 255
#define BASE 10
#define RESOLUTION 50  //number of steps to increment the brightness value


struct cRGB *COLORS[14];
volatile struct cRGB LED_COLOR_old;
volatile struct cRGB LED_COLOR_new;
struct cRGB *LED_COLOR; // pointer to struct as it's handled outside of function

uint8_t calc_new_value(uint8_t value_pwm, float brightness_step);

struct cRGB Colors(uint8_t index){
	COLORS[0]->r=0;		COLORS[0]->g=0;		COLORS[0]->b=0; // black/dark
	COLORS[1]->r=MAX;	COLORS[1]->g=0;		COLORS[1]->b=0; // red
	COLORS[2]->r=MAX;	COLORS[2]->g=MAX/2;	COLORS[2]->b=0; // orange
	COLORS[3]->r=MAX;	COLORS[3]->g=MAX;	COLORS[3]->b=0; // yellow
	COLORS[4]->r=MAX/2;	COLORS[4]->g=MAX;	COLORS[4]->b=0; // green-yellow
	COLORS[5]->r=0;		COLORS[5]->g=MAX;	COLORS[5]->b=0; // green
	COLORS[6]->r=0;		COLORS[6]->g=MAX;	COLORS[6]->b=MAX/2; // mint-green
	COLORS[7]->r=0;		COLORS[7]->g=MAX;	COLORS[7]->b=MAX; // turquois
	COLORS[8]->r=0;		COLORS[8]->g=MAX/2;	COLORS[8]->b=MAX; // light blue
	COLORS[9]->r=0;		COLORS[9]->g=0;		COLORS[9]->b=MAX; // blue
	COLORS[10]->r=MAX/2;COLORS[10]->g=0;	COLORS[10]->b=MAX; // violet
	COLORS[11]->r=MAX;	COLORS[11]->g=0;	COLORS[11]->b=MAX; // pink
	COLORS[12]->r=MAX;	COLORS[12]->g=0;	COLORS[12]->b=MAX/2; // magenta
	COLORS[13]->r=MAX;	COLORS[12]->g=MAX;	COLORS[12]->b=MAX; // white
	return *COLORS[index];	
}

struct cRGB stroboscope(void){
	
}

struct cRGB colorFade(void){	
	uint8_t random_color_value;
	
	int16_t pwm_difference_red		= 0;
	int16_t pwm_difference_green	= 0;
	int16_t pwm_difference_blue		= 0;
	
	float brightness_step_red		= 0.0;
	float brightness_step_green		= 0.0;
	float brightness_step_blue		= 0.0;	
	
	pwm_difference_red		= LED_COLOR_new.r - LED_COLOR_old.r; // Either 0, +-127 or +-255
	pwm_difference_green	= LED_COLOR_new.g - LED_COLOR_old.g; // Either 0, +-127 or +-255
	pwm_difference_blue		= LED_COLOR_new.b - LED_COLOR_old.b; // Either 0, +-127 or +-255
	
	brightness_step_red = 1/RESOLUTION * pwm_difference_red / MAX; // Speed is 0 for same, 1/2 for 127 and 1 for 255 as difference each in positive or negative direction.
	brightness_step_green = 1/RESOLUTION * pwm_difference_green / MAX; // Speed is 0 for same, 1/2 for 127 and 1 for 255 as difference each in positive or negative direction.
	brightness_step_blue = 1/RESOLUTION * pwm_difference_blue / MAX; // Speed is 0 for same, 1/2 for 127 and 1 for 255 as difference each in positive or negative direction.
	
	if(LED_COLOR->r != LED_COLOR_new.r || LED_COLOR->g != LED_COLOR_new.g || LED_COLOR->b != LED_COLOR_new.b){ // as long as final value isn't reached for each color
		LED_COLOR->r = calc_new_value(LED_COLOR->r,brightness_step_red);
		LED_COLOR->g = calc_new_value(LED_COLOR->g,brightness_step_green);
		LED_COLOR->b = calc_new_value(LED_COLOR->b,brightness_step_blue);
	}
	else{
	LED_COLOR_old.r = LED_COLOR->r;
	LED_COLOR_old.g = LED_COLOR->g;
	LED_COLOR_old.b = LED_COLOR->b;
	
	srand(2);
	random_color_value = rand() % 13 +1; // generate random value between 1 and 12 (including 12) 
	LED_COLOR_new.r = Colors(random_color_value).r;
	LED_COLOR_new.g = Colors(random_color_value).g;
	LED_COLOR_new.b = Colors(random_color_value).b;
	}
	
	return *LED_COLOR;
}

struct cRGB colorPulse(uint8_t index){
}
	
uint8_t calc_new_value(uint8_t value_pwm, float brightness_step){
	float value_brightness=0.0;
	value_brightness = log(value_pwm * BASE / 255); //convert logarithmic behaving value to linear one
	value_brightness += brightness_step;// LINEAR!! increase brightness by defined step			
	if (value_brightness <= 0.0){
		value_brightness = 0.0;
		return 0;
	}		
	if (value_brightness > 1.0) value_brightness = 1.0;
	return roundf(1/BASE * MAX * pow(BASE, value_brightness)); // Calculate new PWM-value--> exponential increase in brightness
		
}	

