#include <util/delay.h>
#include <avr/interrupt.h>
#include <avr/io.h>
//#include <avr/sleep.h>

#include "includes/config.h"
#include "includes/debounce.h"
#include "includes/light_ws2812.h"

struct cRGB *LED_OUTPUT;

#define MODES 13

uint8_t index = 1;
uint8_t mode_index = 0;
uint8_t brightness_index = 0;

float brightness_red = 0.3, brightness_green=0.1, brightness_blue=0.5;


int main(void){
	
	/**** Set Timer & Buttons for Debounce Functionality ****/
	KEY_DDR &= ~ALL_KEYS;
	KEY_PORT |= ALL_KEYS;

	TCCR0B = (1<<CS02)|(1<<CS00);         // divide by 1024
	TCNT0 = (uint8_t)(int16_t)-(F_CPU / 1024 * 10e-3 + 0.5);  // preload for 10ms
	TIMSK |= 1<<TOIE0;                   // enable timer interrupt		
	
	sei();		// Enable global interrupts	
	
	*LED_OUTPUT = Colors(13);
	ws2812_setleds(LED_OUTPUT,1);	
	_delay_ms(500);
	*LED_OUTPUT = Colors(0);
	ws2812_setleds(LED_OUTPUT,1);
	_delay_ms(500);	
	
	while(1){
		if( get_key_press(1<<KEY0) ){
			if (mode_index == MODES)mode_index = 0;
			else mode_index += 1;			
		}
		
		if (get_key_long(1<<KEY0)) mode_index =0;
		
		if( get_key_press(1<<KEY1) ){
			if (brightness_index == MODES)brightness_index = 0;
			else brightness_index += 1;			
		}
		
		switch (mode_index){
			case 0: *LED_OUTPUT = colorFade(); _delay_ms(1);break;
			case 1: *LED_OUTPUT = stroboscope(); break;
			case 2: *LED_OUTPUT = colorPulse(1); break;
			default: break;
		}
				
		if(mode_index >= 3){
			*LED_OUTPUT = Colors(mode_index-2); // Cycle colors starting from color "1"
		}
		
		ws2812_setleds(LED_OUTPUT,1);
	}
}